Subject: Re: bug#23098: 25.0.92; (recenter -1) can leave point in the middle of the window

From: Jorgen Schäfer <[email-masked]>
Date: Mon, 28 Mar 2016 17:41:02 +0000

On Mon, Mar 28, 2016 at 7:29 PM Eli Zaretskii <[email-masked]> wrote:

> > From: Jorgen Schäfer <[email-masked]>
> > Date: Mon, 28 Mar 2016 13:10:23 +0000
> > Cc: [email-masked]
> >
> > As an end user, I expect `recenter-to-bottom' to cycle the line with
> point on it between the top, middle and
> > bottom of the current window. The problem described in this report means
> that Emacs does not actually do
> > this – the line with point on it does not ever go even near the bottom
> of the window.
>
> You are judging what Emacs does by the end result: since the result is
> not to have point near the bottom, you deduce that Emacs didn't even
> try.
>

No, I am not. As I explained at length in my last mail.

I actually don't understand why you don't want to set
> scroll-conservatively globally.  From what you say, it sounds like
> that variable is exactly what you want, and not only in this
> situation.  Can you explain why you don't see that as a solution?
>

When scrolling through the buffer with cursor-up/cursor-down, I want
full-page scroll, not single-line scroll.

When I hit C-l, I want point to end up at the bottom at the window.

I do not want to lose the former just so I can have the latter.

And, as the programmer of a mode who tries to keep text at the bottom of
the window, I most certainly do not want to prescribe to the user how their
scrolling with cursor-up/cursor-down behaves just so I can keep the text at
the bottom of the window when I add a line.

These two situations have absolutely nothing to do with each other as far
as the user experience is concerned. The reason why the two interact is
purely technical and an artifact of how Emacs works underneath.

I'd welcome patches to try to fix this, but I think the best fix is
> inside 'recenter': it should detect this situation and behave as if
> its argument was modified so as not to request redisplay of the window
> with window-start point that will cause recentering of point.

Yes, for example. Great idea.

> Interested?

No, thank you.

Regards,
Jorgen